package Echiquier.Modele.Piece;

import Echiquier.Modele.Case;
import Echiquier.Modele.ColorJoueur;

public class Pion extends Piece {
    private boolean estPremierDeplace = true;
    public Pion(ColorJoueur colorJoueur) {
        super(colorJoueur);
    }

    public boolean estDpValide(Case depart, Case arrive) {

        if(estMemeJouer(arrive)){
            return false;
        }

        //le pion ne peut que avancer
        if(depart.getCol() != arrive.getCol()){
            return false;
        }

        //Si le pion est le premier deplacement, il peut avancer 2 case.
        //Sinon, il avance un seul case
        if(estPremierDeplace){
            int nbCase = Math.abs(depart.getLig() - arrive.getLig());
            if( nbCase > 2)
                return false;
            if(nbCase == 2){
                if(echiquier.estBloqueLigne(depart,arrive))
                    return false;
            }
            estPremierDeplace = false;
        }else {
            if( Math.abs(depart.getLig() - arrive.getLig()) != 1)
                return false;
        }

        return true;
    }
}
